part of masamune;

class InlineAppPreview extends StatelessWidget {
  const InlineAppPreview({
    this.initialRoute,
    this.controller,
    this.routes,
    this.widgetTheme,
    this.moduleAdapter,
    this.platformAdapter,
    this.roles,
    this.appModule,
    this.theme,
    this.moduleConfigs = const [],
    this.prefix,
    this.suffix,
  });
  final String? initialRoute;
  final ThemeData? theme;
  final NavigatorController? controller;
  final Map<String, RouteConfig>? routes;
  final WidgetTheme? widgetTheme;
  final ModuleAdapter? moduleAdapter;
  final PlatformAdapter? platformAdapter;
  final List<RoleConfig>? roles;
  final AppModule? appModule;
  final List<ModuleConfig> moduleConfigs;
  final String? prefix;
  final String? suffix;

  @override
  Widget build(BuildContext context) {
    final moduleConfig = ModuleConfig.merge(moduleConfigs);
    return AppScope(
      app: appModule ?? context.app,
      child: AdapterScope(
        moduleAdapter: moduleAdapter ?? context.adapter,
        platformAdapter: platformAdapter ?? context.platform,
        child: RoleScope(
          roles: roles ?? context.roles,
          child: WidgetThemeScope(
            widgetTheme:
                moduleConfig?.widgetTheme ?? widgetTheme ?? context.widgetTheme,
            child: Theme(
              data: moduleConfig?.themeColor?.toThemeData() ??
                  theme ??
                  context.theme,
              child: InlinePageBuilder(
                prefix: prefix ?? "",
                suffix: suffix ?? "",
                initialRoute: initialRoute,
                controller: controller,
                routes: moduleConfig?.routeSettings?.merge(routes) ?? routes,
              ),
            ),
          ),
        ),
      ),
    );
  }
}
